#include <ButtonConstants.au3>
#include <Constants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ListBoxConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
;#include <..\cdebug.au3>
Opt("MustDeclareVars",1)
Opt("TrayIconDebug",1)
Opt("GUICloseOnESC",0)
Global Const $SS_ENDELLIPSIS = 0x4000, $SS_PATHELLIPSIS = 0x8000, $SS_WORDELLIPSIS = 0xC000	; missing from AutoIt
Global Const $SS_ELLIPSISMASK = 0xC000, $SS_TYPEMASK = 0x1F, $SS_EDITCONTROL = 0x2000, $SS_OWNERDRAW = 0xD
Global $gParamStyles,$gParamExStyles	; styles and exStyles parameter of GuiCreate
Global $presetStylesAr[7][2]
$presetStylesAr[1][0] = BitOR($SS_LEFT,$SS_NOPREFIX)
$presetStylesAr[1][1] = 0
$presetStylesAr[2][0] = BitOR($SS_CENTER, $WS_BORDER,$SS_NOPREFIX)
$presetStylesAr[2][1] = 0
$presetStylesAr[3][0] = BitOR($SS_RIGHT,$SS_NOPREFIX)
$presetStylesAr[3][1] = $WS_EX_STATICEDGE
$presetStylesAr[4][0] = $SS_LEFT
$presetStylesAr[4][1] = $WS_EX_DLGMODALFRAME
$presetStylesAr[5][0] = BitOR($SS_CENTER,$SS_PATHELLIPSIS,$SS_SUNKEN)
$presetStylesAr[5][1] = 0
$presetStylesAr[6][0] = $SS_ETCHEDFRAME
$presetStylesAr[6][1] = 0
; $WS_MINIMIZEBOX and $WS_GROUP have the same value. The first applies to Form, the second to controls
; $DS_MODALFRAME, present in Form normal styles, is omitted here because it has the same value as $SS_NOPREFIX
Global Const $kWSstylesAr[15][2] = [[$WS_BORDER,"$WS_BORDER"], [$WS_CHILD,"$WS_CHILD"], [$WS_CLIPCHILDREN,"$WS_CLIPCHILDREN"], _
	[$WS_CLIPSIBLINGS,"$WS_CLIPSIBLINGS"], [$WS_DLGFRAME,"$WS_DLGFRAME"], [$WS_HSCROLL,"$WS_HSCROLL"], _
	[$WS_MAXIMIZE,"$WS_MAXIMIZE"], [$WS_MAXIMIZEBOX,"$WS_MAXIMIZEBOX"], [$WS_MINIMIZE,"$WS_MINIMIZE"], _
	[$WS_GROUP,"$WS_GROUP"], [$WS_POPUP,"$WS_POPUP"], [$WS_SIZEBOX,"$WS_SIZEBOX"], _
	[$WS_SYSMENU,"$WS_SYSMENU"], [$WS_VSCROLL,"$WS_VSCROLL"],[$WS_VISIBLE,"$WS_VISIBLE"]]
Global Const $kLblStylesVec[19] = ["$SS_LEFT", "$SS_CENTER","$SS_RIGHT",-999,"$SS_BLACKRECT","$SS_GRAYRECT","$SS_WHITERECT", _
	"$SS_BLACKFRAME","$SS_GRAYFRAME", "$SS_WHITEFRAME",-999,"$SS_SIMPLE","SS_LEFTNOWORDWRAP","SS_OWNERDRAW",-999,-999, _
	"$SS_ETCHEDHORZ", "$SS_ETCHEDVERT","$SS_ETCHEDFRAME"]
Global Const $kLblStylesAr[8][2] = [[$SS_CENTERIMAGE,"$SS_CENTERIMAGE"],[$SS_EDITCONTROL,"$SS_EDITCONTROL"], _
	[$SS_NOPREFIX,"$SS_NOPREFIX"], [$SS_NOTIFY,"$SS_NOTIFY"],[$SS_SUNKEN,"SS_SUNKEN"], [$SS_WORDELLIPSIS,"SS_WORDELLIPSIS"], _
	[$SS_PATHELLIPSIS,"$SS_PATHELLIPSIS"], [$SS_ENDELLIPSIS,"$SS_ENDELLIPSIS"]]
; Some do not apply to a control; $GUI_WS_EX_PARENTDRAG only applies to a Label
Global Const $kWSexStylesAr[18][2] = [[$WS_EX_ACCEPTFILES,"$WS_EX_ACCEPTFILES"], [$WS_EX_CLIENTEDGE,"$WS_EX_CLIENTEDGE"], _
	[$WS_EX_COMPOSITED,"$WS_EX_COMPOSITED"], [$WS_EX_CONTEXTHELP,"$WS_EX_CONTEXTHELP"], _
	[$WS_EX_CONTROLPARENT,"$WS_EX_CONTROLPARENT"], [$WS_EX_DLGMODALFRAME,"$WS_EX_DLGMODALFRAME"], _
	[$WS_EX_LAYERED,"$WS_EX_LAYERED"], [$WS_EX_LEFTSCROLLBAR,"$WS_EX_LEFTSCROLLBAR"], [$WS_EX_MDICHILD,"$WS_EX_MDICHILD"], _
	[$WS_EX_RIGHT,"$WS_EX_RIGHT"], [$WS_EX_RTLREADING,"$WS_EX_RTLREADING"], [$WS_EX_TRANSPARENT,"$WS_EX_TRANSPARENT"], _
	[$WS_EX_TOOLWINDOW,"$WS_EX_TOOLWINDOW"], [$WS_EX_TOPMOST,"$WS_EX_TOPMOST"],	[$WS_EX_WINDOWEDGE,"$WS_EX_WINDOWEDGE"], _
	[$WS_EX_APPWINDOW,"$WS_EX_APPWINDOW"],[$WS_EX_STATICEDGE,"$WS_EX_STATICEDGE"], _
	[$GUI_WS_EX_PARENTDRAG,"$GUI_WS_EX_PARENTDRAG"]]
#Region ### START Koda GUI section ### Form=F:\AutoIt scripts\Koda devel\Label styles suggestion.kxf
Local $frmLabelStyles = GUICreate("Label Styles", 592, 527, -1, -1, 0)
Local $lblStatus = GUICtrlCreateLabel("Preset", 200, 280, 177, 17, $SS_CENTER)
GUICtrlSetFont(-1, 9, 800, 0, "MS Serif")
GUICtrlSetColor(-1, 0x008000)
Local $gpPresets = GUICtrlCreateGroup("Presets", 8, 8, 177, 97)
Local $radPreset01 = GUICtrlCreateRadio("1", 16, 26, 65, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
Local $radPreset02 = GUICtrlCreateRadio("2", 16, 43, 65, 17)
Local $radPreset03 = GUICtrlCreateRadio("3", 16, 60, 65, 17)
Local $radNone = GUICtrlCreateRadio("None", 64, 77, 65, 17)
Local $radPreset04 = GUICtrlCreateRadio("4", 95, 26, 65, 17)
Local $radPreset05 = GUICtrlCreateRadio("5", 95, 43, 65, 17)
Local $radPreset06 = GUICtrlCreateRadio("6", 95, 60, 65, 17)
GUICtrlSetTip(-1, "-- not yet defined --")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $btnOK = GUICtrlCreateButton("OK", 480, 460, 41, 25)
Local $btnCancel = GUICtrlCreateButton("Cancel", 531, 460, 41, 25)
GUICtrlCreateLabel("AutoIt style parameter", 200, 304, 106, 17)
GUICtrlCreateLabel("AutoIt exStyle parameter", 200, 392, 119, 17)
GUICtrlCreateLabel("Parameters including forced", 392, 9, 135, 17, $WS_CLIPSIBLINGS)
GUICtrlCreateLabel("Autoit or Windows ignored", 392, 104, 128, 17)
GUICtrlCreateLabel("AutoIt or Windows added", 392, 161, 124, 17)
Local $gpAppearance = GUICtrlCreateGroup("Appearance", 200, 8, 177, 169)
Local $chkThinBorder = GUICtrlCreateCheckbox("Thin-line border", 210, 26, 105, 17)
GUICtrlSetTip(-1, "WS_BORDER")
Local $chkDoubleBorder = GUICtrlCreateCheckbox("Double-line border", 210, 60, 113, 17)
GUICtrlSetTip(-1, "WS_EX_DLGMODALFRAME")
Local $chkRaisedClient = GUICtrlCreateCheckbox("Raised interior", 210, 77, 116, 17)
GUICtrlSetTip(-1, "WS_EX_WINDOWEDGE")
Local $chkSunkenClient = GUICtrlCreateCheckbox("Sunken interior", 210, 111, 121, 17)
GUICtrlSetTip(-1, "WS_EX_CLIENTEDGE")
Local $chk3dThinBorder = GUICtrlCreateCheckbox("3-D thin border", 210, 43, 113, 17)
GUICtrlSetTip(-1, "WS_EX_STATICEDGE")
Local $chkHalfSunken = GUICtrlCreateCheckbox("Half-sunken interior", 210, 94, 116, 17)
GUICtrlSetTip(-1, "SS_SUNKEN")
Local $chkLikeEdit = GUICtrlCreateCheckbox("Like Edit control", 210, 153, 121, 17)
GUICtrlSetTip(-1, "SS_EDITCONTROL")
Local $chkCenterImage = GUICtrlCreateCheckbox("One-line text is vertically centered in control", 210, 128, 145, 25, BitOR($GUI_SS_DEFAULT_CHECKBOX,$BS_MULTILINE))
GUICtrlSetTip(-1, "SS_CENTERIMAGE")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $lstStylesWinLacks = GUICtrlCreateList("", 392, 120, 185, 32, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $lstAIstylesInclForced = GUICtrlCreateList("", 392, 24, 185, 71, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $lstStylesWinAdded = GUICtrlCreateList("", 392, 180, 185, 45, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $lstStyleParam = GUICtrlCreateList("", 200, 320, 177, 58, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $lstExStyleParam = GUICtrlCreateList("", 200, 408, 177, 58, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
GUICtrlCreateGroup("Text or Shape", 8, 112, 177, 273)
Local $radLeft = GUICtrlCreateRadio("Left-aligned text", 18, 130, 97, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
GUICtrlSetTip(-1, "SS_LEFT")
Local $radCenter = GUICtrlCreateRadio("Center-aligned text", 18, 147, 121, 17)
GUICtrlSetTip(-1, "SS_CENTER")
Local $radRight = GUICtrlCreateRadio("Right-aligned text", 18, 164, 113, 17)
GUICtrlSetTip(-1, "SS_RIGHT")
Local $radBlackRect = GUICtrlCreateRadio("Black rectangle", 18, 261, 97, 17)
GUICtrlSetTip(-1, "SS_BLACKRECT")
Local $radGrayRect = GUICtrlCreateRadio("Gray rectangle", 18, 244, 97, 17)
GUICtrlSetTip(-1, "SS_GRAYRECT")
Local $radWhiteRect = GUICtrlCreateRadio("White rectangle", 18, 278, 97, 17)
GUICtrlSetTip(-1, "SS_WHITERECT")
Local $radBlackFrame = GUICtrlCreateRadio("Black frame", 18, 295, 97, 17)
GUICtrlSetTip(-1, "SS_BLACKFRAME")
Local $radGrayFrame = GUICtrlCreateRadio("Gray frame", 18, 312, 97, 17)
GUICtrlSetTip(-1, "SS_GRAYFRAME")
Local $radEtchedFrame = GUICtrlCreateRadio("Etched frame", 18, 329, 97, 17)
GUICtrlSetTip(-1, "SS_ETCHEDFRAME")
Local $radSimple = GUICtrlCreateRadio("Crude, fast text", 18, 198, 97, 17)
GUICtrlSetTip(-1, "SS_SIMPLE")
Local $radLeft1line = GUICtrlCreateRadio("Left aligned, one line only", 18, 181, 145, 17)
GUICtrlSetTip(-1, "SS_LEFTNOWORDWRAP")
Local $radEtchedHorz = GUICtrlCreateRadio("Etched horizontal line", 18, 346, 145, 17)
GUICtrlSetTip(-1, "SS_ETCHEDHORZ")
Local $radEtchedVert = GUICtrlCreateRadio("Etched vertical line", 18, 363, 145, 17)
GUICtrlSetTip(-1, "SS_ETCHEDVERT")
GUICtrlCreateLabel("Label1", 34, 237, 120, 2, $SS_ETCHEDHORZ)
Local $radUserPaints = GUICtrlCreateRadio("User's code paints control", 18, 215, 145, 17)
GUICtrlSetTip(-1, "SS_OWNERDRAW")
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("Force-fit on one line", 8, 392, 177, 97)
Local $radPathEllipsis = GUICtrlCreateRadio("Replace ... between \s", 18, 410, 153, 17)
GUICtrlSetTip(-1, "SS_PATHELLIPSIS")
Local $radEndEllipsis = GUICtrlCreateRadio("Truncate at character with ...", 18, 427, 161, 17)
GUICtrlSetTip(-1, "SS_ENDELLIPSIS")
Local $radWordEllipsis = GUICtrlCreateRadio("Truncate at word with ...", 18, 444, 137, 17)
GUICtrlSetTip(-1, "SS_WORDELLIPSIS")
Local $radAllowMultiLines = GUICtrlCreateRadio("Allow multiple lines", 18, 461, 121, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
GUICtrlSetTip(-1, "default")
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("Miscellaneous", 200, 184, 177, 89)
Local $Checkbox1 = GUICtrlCreateCheckbox("Checkbox1", 280, 208, 1, 9)
Local $chkNoPrefix = GUICtrlCreateCheckbox("&& is a character, not an accelerator prefix", 210, 202, 137, 25, BitOR($GUI_SS_DEFAULT_CHECKBOX,$BS_MULTILINE))
GUICtrlSetTip(-1, "SS_NOPREFIX")
Local $chkOverpaint = GUICtrlCreateCheckbox("Over-paint other controls", 210, 227, 145, 17)
GUICtrlSetTip(-1, "WS_CLIPSIBLINGS")
Local $chkDragForm = GUICtrlCreateCheckbox("Is drag handle for form", 194, 253, 129, 17)
GUICtrlSetTip(-1, "GUI_WS_EX_PARENTDRAG")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $gpTest = GUICtrlCreateGroup("Test", 392, 240, 185, 169)
GUICtrlCreateLabel("Show time", 418, 270, 59, 17)
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
Local $inpShowTestSecs = GUICtrlCreateInput("2", 478, 268, 38, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_RIGHT,$ES_READONLY))
GUICtrlSetBkColor(-1, 0xFFFFFF)
Local $Updown1 = GUICtrlCreateUpdown($inpShowTestSecs)
GUICtrlSetLimit(-1, 30, 1)
GUICtrlCreateLabel("secs", 522, 270, 32, 17)
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
Local $chkShowTestForm = GUICtrlCreateCheckbox("Show", 500, 300, 57, 17, BitOR($GUI_SS_DEFAULT_CHECKBOX,$BS_PUSHLIKE))
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

Const $allChksVec[10] = [$chkCenterImage, $chkDoubleBorder, $chkHalfSunken, $chkNoPrefix, $chkOverpaint, $chkParentDrag, _
	$chkRaisedClient, $chkSunkenClient, $chkThinBorder, $chk3dThinBorder]
DoPreset(1)
;AutoIt_Debugger_Command:Disable_Debug
While 1
	Local $nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE,$btnCancel,$btnOK
			Exit
		Case $chk3dThinBorder
			DoCheckBox($nMsg,0,$WS_EX_STATICEDGE)
		Case $chkCenterImage
			DoCheckBox($nMsg,$SS_CENTERIMAGE,0)
		Case $chkDoubleBorder
			DoCheckBox($nMsg,$WS_DLGFRAME,0)
;			DoCheckBox($nMsg,0,$WS_EX_DLGMODALFRAME)
		Case $chkLikeEdit
			DoCheckBox($nMsg,$SS_EDITCONTROL,0)
		Case $chkHalfSunken
			DoCheckBox($nMsg,$SS_SUNKEN,0)
		Case $chkNoPrefix
			DoCheckBox($nMsg,$SS_NOPREFIX,0)
		Case $chkOverpaint
			DoCheckBox($nMsg,$WS_CLIPSIBLINGS,0)
		Case $chkParentDrag
			DoCheckBox($nMsg,0,$GUI_WS_EX_PARENTDRAG)
		Case $chkRaisedClient
			DoCheckBox($nMsg,0,$WS_EX_WINDOWEDGE)
		Case $chkSunkenClient
			DoCheckBox($nMsg,0,$WS_EX_CLIENTEDGE)
		Case $chkThinBorder
			DoCheckBox($nMsg,$WS_BORDER,0)
		Case $chkShowTestForm
			Show()
		Case $inpShowTestSecs
			If GUICtrlRead($inpShowTestSecs)>0 Then
				GUICtrlSetState($chkShowTestForm,$GUI_ENABLE)
			Else
				GUICtrlSetState($chkShowTestForm,$GUI_UNCHECKED)
				GUICtrlSetState($chkShowTestForm,$GUI_DISABLE)
			EndIf
		Case $radPreset01
			DoPreset(1)
		Case $radPreset02
			DoPreset(2)
		Case $radPreset03
			DoPreset(3)
		Case $radPreset04
			DoPreset(4)
		Case $radPreset05
			DoPreset(5)
		Case $radPreset06
			DoPreset(6)
		Case $radNone
			DoPreset(0)
		Case $radAllowMultiLines
			DoRadioForceFit($nMsg,0)
		Case $radBlackFrame
			DoRadioTextOrShape($nMsg,$SS_BLACKFRAME)
		Case $radBlackRect
			DoRadioTextOrShape($nMsg,$SS_BLACKRECT)
		Case $radCenter
			DoRadioTextOrShape($nMsg,$SS_CENTER)
		Case $radEndEllipsis
			DoRadioForceFit($nMsg,$SS_ENDELLIPSIS)
		Case $radEtchedFrame
			DoRadioTextOrShape($nMsg,$SS_ETCHEDFRAME)
		Case $radEtchedHorz
			DoRadioTextOrShape($nMsg,$SS_ETCHEDHORZ)
		Case $radEtchedVert
			DoRadioTextOrShape($nMsg,$SS_ETCHEDVERT)
		Case $radGrayFrame
			DoRadioTextOrShape($nMsg,$SS_GRAYFRAME)
		Case $radGrayRect
			DoRadioTextOrShape($nMsg,$SS_GRAYRECT)
		Case $radLeft
			DoRadioTextOrShape($nMsg,$SS_LEFT)
		Case $radLeft1line
			DoRadioTextOrShape($nMsg,$SS_LEFTNOWORDWRAP)
		Case $radPathEllipsis
			DoRadioForceFit($nMsg,$SS_PATHELLIPSIS)
		Case $radRight
			DoRadioTextOrShape($nMsg,$SS_RIGHT)
		Case $radSimple
			DoRadioTextOrShape($nMsg,$SS_SIMPLE)
		Case $radUserPaints
			DoRadioTextOrShape($nMsg,$SS_OWNERDRAW)
		Case $radWhiteRect
			DoRadioTextOrShape($nMsg,$SS_WHITERECT)
		Case $radWordEllipsis
			DoRadioForceFit($nMsg,$SS_WORDELLIPSIS)
	EndSwitch
WEnd
;AutoIt_Debugger_Command:Enable_Debug

Func DoPreset($nPres)
	Switch $nPres
	Case 1
		Local $chksVec[3] = [$radLeft,$radAllowMultiLines,$chkNoPrefix]
	Case 2
		Local $chksVec[4] = [$radCenter,$chkThinBorder,$radAllowMultiLines,$chkNoPrefix]
	Case 3
		Local $chksVec[4] = [$radRight,$chk3dThinBorder,$radAllowMultiLines,$chkNoPrefix]
	Case 4
		Local $chksVec[4] = [$radLeft,$chkDoubleBorder,$radAllowMultiLines,$chkNoPrefix]
	Case 5
		Local $chksVec[4] = [$radCenter,$radPathEllipsis,$chkHalfSunken,$chkNoPrefix]
	Case 6
		Local $chksVec[1] = [$radEtchedFrame]
	Case 0	; none
		Local $chksVec = 0
	Case Else
		MsgBox(0,"","Not defined yet")
		Return
	EndSwitch
	For $i = 0 to UBound($allChksVec)-1
		GUICtrlSetState($allChksVec[$i],$GUI_UNCHECKED)
	Next
	If IsArray($chksVec) Then
		For $i = 0 To UBound($chksVec)-1
			GUICtrlSetState($chksVec[$i],$GUI_CHECKED)
		Next
	EndIf
	$gParamStyles = $presetStylesAr[$nPres][0]
	$gParamExStyles = $presetStylesAr[$nPres][1]
	Show()
EndFunc

Func DoRadioForceFit($ctrlID,$nStyle)
	If IsChecked($ctrlID) Then
		Local $n = $gParamStyles
		$n = BitAND($n,BitNOT($SS_WORDELLIPSIS))	; 0xC000
		$n = BitOR($n,$nStyle)
		$gParamStyles = $n
	EndIf
	Show()
EndFunc

Func DoRadioTextOrShape($ctrlID,$nStyle)
	If IsChecked($ctrlID) Then
		Local $n = $gParamStyles
		$n = BitAND($n,BitNOT($SS_TYPEMASK))
		$n = BitOR($n,$nStyle)
		$gParamStyles = $n
	EndIf
	Show()
EndFunc

Func DoCheckBox($ctrlID,$nStyle,$nExStyle)
	If $nStyle<>0 Then
		If IsChecked($ctrlID) Then
			$gParamStyles = BitOR($gParamStyles,$nStyle)
		Else
			$gParamStyles = BitAND($gParamStyles,BitNOT($nStyle))
		EndIf
	EndIf
	If $nExStyle<>0 Then
		If IsChecked($ctrlID) Then
			$gParamExStyles = BitOR($gParamExStyles,$nExStyle)
		Else
			$gParamExStyles = BitAND($gParamExStyles,BitNOT($nExStyle))
		EndIf
	EndIf
	Show()
EndFunc

Func Show()
	Local $t
	$t = ConvertStylesToText($gParamStyles)
	GUICtrlSetData($lstStyleParam,"|"&$t)
	$t = ConvertExStylesToText($gParamExStyles)
	GUICtrlSetData($lstExStyleParam,"|"&$t)

	Local $winInStyles = BitOR($gParamStyles,$SS_NOTIFY)	 ; forced by AutoIt
	Local $winInExStyles = $gParamExStyles
	ShowAllStyles($winInStyles,$winInExStyles,$lstAIstylesInclForced)

	Local $winOutStyles,$winOutExStyles
	If ShowStatus($winOutStyles,$winOutExStyles) Then
		Local $winLacks,$winAdded,$winExLacks,$winExAdded
		CompareNormStyles($winInStyles,$winOutStyles,$winLacks,$winAdded)
		CompareExStyles($winInExStyles,$winOutExStyles,$winExLacks,$winExAdded)
		ShowAllStyles($WinLacks,$WinExLacks,$lstStylesWinLacks)
		ShowAllStyles($winAdded,$winExAdded,$lstStylesWinAdded)
		Local $nShowSecs = GUICtrlRead($inpShowTestSecs)
;		UpdateTestLabel()
		If IsChecked($chkShowTestForm) and Not IsChecked($radUserPaints) Then ShowTestForm($nShowSecs)
	Else
		GUICtrlSetData($lstStylesWinLacks,"")
		GUICtrlSetData($lstStylesWinAdded,"")
	EndIf
EndFunc
Func IsChecked($ctrlID)
	Return BitAND(GUICtrlRead($ctrlID),$GUI_CHECKED)=$GUI_CHECKED
EndFunc

Func ShowStatus(ByRef $winOutStyles,ByRef $winOutExStyles)
Local $n = 0,$hForm
	for $i = 1 to UBound($presetStylesAr,1)-1
		If $presetStylesAr[$i][0]=$gParamStyles And $presetStylesAr[$i][1]=$gParamExStyles Then
			$n = $i
			ExitLoop
		EndIf
	Next
	$hForm = GUICreate("title",200,200,-200,-200)
	If $hForm=0 Or @error<>0 Then
		MsgBox(4096,"Error","GuiCreate() in ShowStatus failed")
	EndIf
	Local $ctrlID = GUICtrlCreateLabel("Label1",10,10,180,180,$gParamStyles,$gParamExStyles)
	Local $bWorks = $ctrlID<>0 and @error=0
	if $bWorks Then
		Local $hndl = GUICtrlGetHandle($ctrlID)
		$winOutStyles = _C_GetWindowLong($hndl,$GWL_STYLE)
		$winOutExStyles = _C_GetWindowLong($hndl,$GWL_EXSTYLE)
		GUIDelete($hndl)
		GUICtrlSetState($btnOK,$GUI_ENABLE)
	Else
		$winOutStyles = 0
		$winOutExStyles = 0
		GUICtrlSetState($btnOK,$GUI_DISABLE)
	EndIf
	Switch True
	Case $n>0
		GUICtrlSetData($lblStatus,"Preset " & $n)
		GUICtrlSetColor($lblStatus,0x007f00)	; green
	case $bWorks
		GUICtrlSetData($lblStatus,"Custom")
		GUICtrlSetColor($lblStatus,0x0000ff)	; blue
	Case Else
		GUICtrlSetData($lblStatus,"Failed")
		GUICtrlSetColor($lblStatus,0xff0000)	; red
	EndSwitch
	Return $bWorks
EndFunc
Func CompareNormStyles($in,$out,ByRef $lacks,ByRef $added)
	$lacks = 0
	$added = 0
	If $out=$in Then
		Return True
	Else
		Local $vec[2] = [$SS_TYPEMASK,$SS_ELLIPSISMASK],$m,$n
		For $el In $vec
			$m = BitAND($in,$el)
			$n = BitAND($out,$el)
			If $m<>$n Then
				$added += $n
				$lacks += $m
			EndIf
			$in = BitAND($in,BitNOT($el))
			$out = BitAND($out,BitNOT($el))
		Next
		For $iShft = 0 to 31
			Local $mask = BitShift(1,-$iShft)		; negative is left
			If BitAND($out,$mask)<>BitAND($in,$mask) Then
				If BitAND($out,$mask)<>0 Then
					$added = BitOR($added,$mask)
				Else
					$lacks = BitOR($lacks,$mask)
				EndIf
			EndIf
		Next
		Return False
	EndIf
EndFunc
Func CompareExStyles($in,$out,ByRef $lacks,ByRef $added)
	$lacks = 0
	$added = 0
	If $out=$in Then
		Return True
	Else
		For $iShft = 0 to 31
			Local $mask = BitShift(1,-$iShft)		; negative is left
			If BitAND($out,$mask)<>BitAND($in,$mask) Then
				If BitAND($out,$mask)<>0 Then
					$added = BitOR($added,$mask)
				Else
					$lacks = BitOR($lacks,$mask)
				EndIf
			EndIf
		Next
		Return False
	EndIf
EndFunc

Func ShowAllStyles($nStyles,$nExStyles,$ctrlID)
	Local $t=""
	Local $n = BitAND($nStyles,$SS_TYPEMASK)
	if $n<>$SS_LEFT Then
		$t = $kLblStylesVec[$n]
		$nStyles = BitAND($nStyles,BitNOT($SS_TYPEMASK))
	EndIf
	$t = ConvertWinConstsToStringBitwise($kWSstylesAr,$nStyles,$t)
	If $nStyles<>0 Then
		$t = ConvertWinConstsToStringBitwise($kLblStylesAr,$nStyles,$t)
		If $nStyles<>0 Then
			MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown style(s) 0x" & Hex($nStyles))
		EndIf
	EndIf
	$t = ConvertWinConstsToStringBitwise($kWSexStylesAr,$nExStyles,$t)
	If $nExStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown exStyle(s) 0x" & Hex($nExStyles))
	EndIf
	GUICtrlSetData($ctrlID,"|"&$t)
EndFunc

Func ConvertWinConstsToStringBitwise($ar,ByRef $n,$t)
	For $i = 0 to UBound($ar,1)-1
		If ($n=0) Then ExitLoop
		If BitAND($n,$ar[$i][0])=$ar[$i][0] Then
			If $t<>"" Then $t &= "|"
			$t &=  $ar[$i][1]
			$n = BitAND($n,BitNOT($ar[$i][0]))
		EndIf
	Next
	Return $t
EndFunc
#cs
Func UpdateTestLabel()
Local $t
	If IsChecked($radPathEllipsis) or IsChecked($radEndEllipsis) or IsChecked($radWordEllipsis) Then
		$t = "F:\Program Files\AutoIt3\SciTE\Koda\FD.exe"
	Else
		$t = "Koda was developed to help assist with the creation of forms (GUIs) for the AutoIt3 scripting language."
	EndIf
	GUICtrlSetData($lblTest,$t)
	GUICtrlSetStyle($gParamStyles,$gParamExStyles)
EndFunc
#ce

Func ShowTestForm($nShowSecs)
	Local $left,$top,$testForm,$t
Opt("GUICloseOnESC",1)
	Local $hndl = GUICtrlGetHandle($gpTest)
	Local $vec = WinGetPos($hndl)	; left, top, width, height
	$testForm = GUICreate("Test Form", $vec[2]-20, $vec[3]-30, $vec[0]+10, $vec[1]+15,$WS_POPUP)
	Switch True
	Case IsChecked($radPathEllipsis)
		$t = "F:\Program Files\AutoIt3\SciTE\Koda\FD.exe"
	Case Else
		$t = "Koda was developed to help assist with the creation of forms (GUIs) for the AutoIt3 scripting language."
	EndSwitch
	GUICtrlCreateLabel($t, 8, 8, $vec[3]-16, 60,$gParamStyles,$gParamExStyles)
	GUICtrlCreateLabel("Press Esc key to close", 8, 80, 164, 40)
	GUISetState(@SW_SHOW)
	WinSetState($frmLabelStyles,"",@SW_DISABLE)
	GUISwitch($TestForm)
	Local $stTime = TimerInit()
	While 1
		Local $nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
		EndSwitch
		If TimerDiff($stTime)>$nShowSecs*1000 Then
			ExitLoop
		EndIf
	WEnd
Opt("GUICloseOnESC",0)
	WinSetState($frmLabelStyles,"",@SW_ENABLE)
	GUISwitch($frmLabelStyles)
	GUIDelete($testForm)
EndFunc

Func ConvertStylesToText($nStyles)
	Local $t=""
	Local $n = BitAND($nStyles,$SS_TYPEMASK)
	If $n<>$SS_LEFT Then
		$t = $kLblStylesVec[$n]
		$nStyles = BitAND($nStyles,BitNOT($SS_TYPEMASK))
	EndIf
	$t = ConvertWinConstsToStringBitwise($kWSstylesAr,$nStyles,$t)
	If $nStyles<>0 Then
		$t = ConvertWinConstsToStringBitwise($kLblStylesAr,$nStyles,$t)
		If $nStyles<>0 Then
			MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown style(s) 0x" & Hex($nStyles))
		EndIf
	EndIf
	Return $t
EndFunc

Func ConvertExStylesToText($nExStyles)
Local $t
	$t = ConvertWinConstsToStringBitwise($kWSexStylesAr,$nExStyles,$t)
	If $nExStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown ExStyle(s) 0x" & Hex($nExStyles))
	EndIf
	Return $t
EndFunc

; Copied from WinAPI.au3
Func _C_GetWindowLong($hWnd, $iIndex)
	Local $sFuncName = "GetWindowLongW"
	If @AutoItX64 Then  $sFuncName = "GetWindowLongPtrW"
	Local $aResult = DllCall("user32.dll", "long_ptr", $sFuncName, "hwnd", $hWnd, "int", $iIndex)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc   ;==>_C_GetWindowLong

; Copied from WinAPI.au3
Func _C_SetWindowLong($hWnd, $iIndex, $iValue)
	_C_SetLastError(0)	; as suggested in MSDN
	Local $sFuncName = "SetWindowLongW"
	If @AutoItX64 Then  $sFuncName = "SetWindowLongPtrW"
	Local $aResult = DllCall("user32.dll", "long_ptr", $sFuncName, "hwnd", $hWnd, "int", $iIndex, "long_ptr", $iValue)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc   ;==>_C_SetWindowLong

; Copied from WinAPIError.au3
Func _C_SetLastError($iErrCode, $curErr=@error, $curExt=@extended)
	DllCall("kernel32.dll", "none", "SetLastError", "dword", $iErrCode)
	Return SetError($curErr, $curExt)
EndFunc   ;==>_C_SetLastError
